Форум программистов, компьютерный форум CyberForum.ru

Про наследование от exception - C++

Восстановить пароль Регистрация
 
Рейтинг: Рейтинг темы: голосов - 38, средняя оценка - 4.63
dikanev
21 / 21 / 1
Регистрация: 28.05.2010
Сообщений: 67
22.11.2010, 21:11     Про наследование от exception #1
Есть пример наследования класса для создания собственных исключений:
C++
1
2
3
4
5
6
class MyException: public std::exception {
    virtual const char* what() const throw()
    {
        return "My exception happened";
    }
};
Подскажите, а что означает "const throw()" после заголовка метода?
После регистрации реклама в сообщениях будет скрыта и будут доступны все возможности форума.
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
22.11.2010, 23:47     Про наследование от exception #2
Спецификатор "const" означает, что функция не модифицирует объект, а "throw" — что функция может кинуть исключение.

Добавлено через 8 минут
Вернее, в данном случае, поскольку внутри скобок после "throw" ничего нет, то гарантируется бессбойность. А если бы там стоял какой-то тип, то это бы говорило о возможности кинуть исключение этого типа.
st_dent
64 / 64 / 3
Регистрация: 05.07.2010
Сообщений: 219
22.11.2010, 23:48     Про наследование от exception #3
Цитата Сообщение от volovzi Посмотреть сообщение
А если бы там стоял какой-то тип, то это бы говорило о возможности кинуть исключение этого типа.
А пример не приведете?
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
22.11.2010, 23:51     Про наследование от exception #4
Боюсь соврать, потому что исключениями почти не пользуюсь .
ForEveR
Модератор
Эксперт C++
 Аватар для ForEveR
7927 / 4709 / 318
Регистрация: 24.06.2010
Сообщений: 10,524
Завершенные тесты: 3
22.11.2010, 23:57     Про наследование от exception #5
Сообщение было отмечено автором темы, экспертом или модератором как ответ
Пример. Исключения кидаются, НО пишется ворнинг, что функция не должна бы кидать исключения.

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
#include <iostream>
 
void foo(int i) throw()
{
    if(i==0)
        throw 0;
    else
        throw "Hello";
}
 
int main()
{
    try
    {
        foo(0);
    }
    catch(...)
    {
        std::cout<<"Catch exception\n";
    }
    return 0;
}
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:05     Про наследование от exception #6
Сообщение было отмечено автором темы, экспертом или модератором как ответ
Позволю себе немного упростить предыдущий пример:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
#include <iostream>
 
void foo () throw () {
    throw std::string("Исключение");
}
 
int main () {
    try {
        foo();
    } catch (std::string & exception) {
        std::cout << exception;
        }
        
    return 0;
}
Если убрать спецификатор "throw ()" из описания функции, то строка напечатается, а если оставить, то должна быть ошибка времени выполнения.
st_dent
64 / 64 / 3
Регистрация: 05.07.2010
Сообщений: 219
23.11.2010, 00:08     Про наследование от exception #7
Цитата Сообщение от ForEveR Посмотреть сообщение
Пример. Исключения кидаются, НО пишется ворнинг, что функция не должна бы кидать исключения.
Все-таки непонятно зачем тут throw()
C++
1
void foo () throw ()
вот так результат тот же самый:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
#include <iostream>
 
void foo(int i) 
{
        if(i==0)
                throw 0;
        else
                throw "Hello";
}
 
 
[b]volovzi[/b], выше уже ответил
 
int main()
{
        try
        {
                foo(1);
        }
        catch(...)
        {
                std::cout<<"Catch exception\n";
        }
        return 0;
}
volovzi, выше уже ответил
ForEveR
Модератор
Эксперт C++
 Аватар для ForEveR
7927 / 4709 / 318
Регистрация: 24.06.2010
Сообщений: 10,524
Завершенные тесты: 3
23.11.2010, 00:11     Про наследование от exception #8
volovzi, Не согласен. Ошибка выполнения не прошла даже с throw(). Возможно, MSVS опять что-то намутило со стандартом...
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:15     Про наследование от exception #9
Я отвечаю только за gcc и юникс .
Вот что мне сообщают:
Код
terminate called after throwing an instance of 'std::string'
Program received signal:  “SIGABRT”.
ForEveR
Модератор
Эксперт C++
 Аватар для ForEveR
7927 / 4709 / 318
Регистрация: 24.06.2010
Сообщений: 10,524
Завершенные тесты: 3
23.11.2010, 00:16     Про наследование от exception #10
volovzi, Ну да... MSVS как всегда...
У меня не вылетает даже так.

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
#include <iostream>
#include <string>
 
__declspec(nothrow) void foo () {
        throw std::string("Исключение");
}
 
int main () {
        try {
                foo();
        } catch (std::string & exception) {
                std::cout << exception;
        }
            
        return 0;
}
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:55     Про наследование от exception #11
ForEveR, и вообще ничего не говорит? Странно.
ForEveR
Модератор
Эксперт C++
 Аватар для ForEveR
7927 / 4709 / 318
Регистрация: 24.06.2010
Сообщений: 10,524
Завершенные тесты: 3
23.11.2010, 00:58     Про наследование от exception #12
volovzi, Более того. Путем тестов было выяснено, что MSVS редко реагирует на throw.

На gcc ведь будет рантайм не так-ли?

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
#include <iostream>
 
void foo() throw (int)
{
    throw "exc";
}
 
int main()
{
    try
    {
        foo();
    }
    catch(...)
    {
        std::cout<<"Exc\n";
    }
    return 0;
}
volovzi
266 / 168 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:59     Про наследование от exception #13
Угу:
Код
terminate called after throwing an instance of 'char*'
Program received signal:  “SIGABRT”.
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
23.11.2010, 01:01     Про наследование от exception
Еще ссылки по теме:

Наследование класса Exception C++
Const throw(), наследование от класса exception C++
Создание своего класса исключений, наследование std::exception C++

Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
ForEveR
Модератор
Эксперт C++
 Аватар для ForEveR
7927 / 4709 / 318
Регистрация: 24.06.2010
Сообщений: 10,524
Завершенные тесты: 3
23.11.2010, 01:01     Про наследование от exception #14
volovzi, ну вот. а в студии спокойно печатает сообщение.
Yandex
Объявления
23.11.2010, 01:01     Про наследование от exception
Ответ Создать тему
Опции темы

Текущее время: 10:17. Часовой пояс GMT +3.
КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2016, vBulletin Solutions, Inc.
Рейтинг@Mail.ru